/*************************************************** 
  Based on an example for the Adafruit 16-channel PWM & Servo driver
  ------> http://www.adafruit.com/products/815
 ****************************************************/

#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>

Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x40); // 0x40 is the default I2C address

// variables for the 5 LEDs on the inner ring of the star
bool ledON = false;
int minLED = 3;
int maxLED = 7;
int countLED = minLED;

// random LEDs will be switched on or off
int randOuterLED;
int randInnerLED;
int randBrightness;
int centerIncrease = 100;
int maxBrightness = 3000;
int minBrightness =500;
int centerBrightness = minBrightness;

void setup() {
  Serial.begin(9600);
  Serial.println("16 channel PWM LED Star!");

// setting output pins for 5 inner LEDs on the star
  for (int j = minLED; j <= maxLED; j++) {
    pinMode(j,OUTPUT);
  }

  pwm.begin();
  pwm.setOscillatorFrequency(25000000);
  pwm.setPWMFreq(1600);  // This is the maximum PWM frequency

  // if you want to really speed stuff up, you can go into 'fast 400khz I2C' mode
  // some i2c devices dont like this so much so if you're sharing the bus, watch
  // out for this!
  Wire.setClock(400000);
}

void loop() {
//  for (uint16_t i=0; i<4096; i += 8) {
//    for (uint8_t pwmnum=0; pwmnum < 16; pwmnum++) {
//      pwm.setPWM(pwmnum, 0, (i + (4096/16)*pwmnum) % 4096 );
//    }
  // all LEDs on the outer Ring will be set to a random value
  for (int j = 0; j < 15; j++) {
    randOuterLED = j;
    randBrightness = random(minBrightness,maxBrightness);
    pwm.setPWM(randOuterLED, 0, randBrightness);
    Serial.println(randOuterLED);
    Serial.println(randBrightness);
  }
  
  // center LED will increase and decrease
  pwm.setPWM(15, 0, centerBrightness);
  centerBrightness += centerIncrease;
  if (centerBrightness > maxBrightness) centerIncrease = -centerIncrease;
  if (centerBrightness < minBrightness) centerIncrease = -centerIncrease;
  
  // LEDs on the inner ring will be toggled consecutively
  if (ledON) digitalWrite(countLED, HIGH);
  else       digitalWrite(countLED, LOW);
  ledON = !ledON;
  countLED++;
  Serial.println(ledON);
  Serial.println();
  if (countLED > maxLED) countLED = minLED;
  
  // wait 100ms
  delay(100);
}
